#define NUM_FLOORS 5
#define NUM_USERS 3
#define UP 1
#define DOWN 2
#define IDLE 0
#define OPEN 1
#define CLOSED 0

// State - which floor's button is pushed, 
bool button[NUM_FLOORS];
int motion = IDLE;
byte floor = 0;
bool door = CLOSED;

// Elevator controller manages by moving to 
// the top and then to the lowest floor
// Should be 'safe and live'
proctype safe_live_elevator(){
}

proctype optimal_safe_live_elevator() {
  // code that controls the elevator goes here
  //min-max
}

active proctype simple_elevator() {
  // code that controls the elevator goes here
  // moves the elevator to the lowest floor with a pending request.

  int lowestFloor;
  do
    :: lowestFloor = -1;
        int i;
      for (i : 0 .. ( NUM_FLOORS - 1)) {
        if 
          :: button[i] == true ->
            lowestFloor = i;
            break;
          :: else -> skip;
        fi;
      }

        do
          :: lowestFloor == -1 -> break;
          :: else ->
            if
              :: lowestFloor > floor ->
                motion = UP;
                floor++;
              :: lowestFloor < floor ->
                motion = DOWN;
                floor--;
              :: lowestFloor == floor ->
                door = OPEN;  
                motion = IDLE;

                button[lowestFloor] = false;
                printf("picked up at floor %d, now %d\n", lowestFloor, 
                  button[lowestFloor]);
                door = CLOSED; // close door when in motion
                break;
            fi;
        od;
    od;
}

active [NUM_USERS] proctype user() {
  int req;
  do
    ::  
        // non-deterministically pick a random floor 
        req = 0; 
        do
        :: req < (NUM_FLOORS - 1) -> req++;
        :: break;
        od;

        button[req] = 1;
        printf("requested floor: %d\n", req);
        !button[req];
  od;
}

// If the door is open the motion is IDLE.
ltl door_safety {
}

// If a button is pressed the elevator will eventually reach that floor.
ltl no_starvation {
}

ltl no_pointless_trips {
}

