cohen kappa for files ("XXX.tsv" "YYY.tsv") ...
 0.91

confusion matrix for ("XXX.tsv" "YYY.tsv") ...
((rows "XXX.tsv")
 (columns "YYY.tsv")
 (tags
  ((0 "BadProp")
   (1 "BadStateIndex")
   (2 "BadStateQuantification")
   (3 "ImplicitF")
   (4 "ImplicitG")
   (5 "OtherImplicit")
   (6 "WeakUntil")
   (7 "Precedence")
   (8 "ReasonableVariant")))
 #(#(2 0 0 0 2 0 0 0 1)
   #(0 0 0 1 2 0 1 0 0)
   #(0 0 3 0 0 0 1 0 2)
   #(0 0 0 3 2 0 0 0 0)
   #(2 0 0 2 7 1 0 0 2)
   #(0 1 0 0 0 3 0 0 1)
   #(0 0 0 0 0 0 0 0 0)
   #(0 0 0 0 0 0 0 2 0)
   #(0 0 0 0 0 2 0 1 9)))

### column B
> Q. Whenever the Red light is on, it turns off in the next state and on again in the state after that.
> A. always { (Red in Panel.lit) implies after { Red not in Panel.lit } and (Red not in Panel.lit) implies after { Red in Panel.lit } }

#### XXX.tsv = ((Precedence and ReasonableVariant))
- blinker with bad ()

#### YYY.tsv = ((Precedence))
- There are two problems here. The first is what looks like a classic precedence issue ("implies ... and ... implies"; explicit and binds tighter than implies; I can never remember if implies is left- or right-associative). Adding those parentheses aren't enough to fix the issue, but adding another set, for the first after, would. There's a chance this is BadStateIndex (expecting the after operator to "carry" across the and), or a ReasonableVariant with implicitG --- but by the letter of the rubric, I think I should code this Precedence and move on.


### column C
> Q. Whenever the Red light is on, it turns off in the next state and on again in the state after that.
> A. always {Red in Panel.lit implies (after Red not in Panel.lit and after Red in Panel.lit)}

#### XXX.tsv = ((Precedence))
- missing () from 1st after to end

#### YYY.tsv = ((Precedence))
- This could be a precedence issue (missing brackets after after) but its semantic effect is BadStateIndex. No way to tell if misconception or typo.


### column D
> Q. The Red light is on in exactly one state, but not necessarily the first state
> A. (Red in Panel.lit) implies (not eventually Red in Panel.lit)

#### XXX.tsv = ((BadStateIndex and ImplicitF and ImplicitG))
- BSI = impliesThen, IF = lhs happens, IG = toplevel

#### YYY.tsv = ((ImplicitF and ImplicitG))
- Two problems here. 1: obligation to stay off only applies in first state; that's ImplicitG. 2: "apparent belief that some subterm has to happen eventually" for ImplicitF.


### column E
> Q. The Red light is on in exactly one state, but not necessarily the first state
> A. eventually {(Red in Panel.lit) and (after always not Red in Panel.lit)}

#### XXX.tsv = ((OtherImplicit))
- OI = never lit before the F

#### YYY.tsv = ((OtherImplicit))
- This is a "strong eventually" sort of thing: they aren't considering that there might be other YYYes the light is lit before this one. Neither ImplicitG or ImplicitF applies.


### column F
> Q. The Red light is on in exactly one state, but not necessarily the first state
> A. eventually {Red in Panel.lit and not {eventually{Red in Panel.lit}}}

#### XXX.tsv = ((OtherImplicit))
- OI = never lit before the F

#### YYY.tsv = ((BadStateIndex and OtherImplicit))
- This answer has the same problem as in the previous column, but it also neglects to offset the index at which the 2nd `eventually` is evaluated. Since that's a subterm evaluated at the wrong index, it is a BadStateIndex.


### column G
> Q. The Red light is on in exactly one state, but not necessarily the first state
> A. always { ((Red not in Panel.lit) until (Red in Panel.lit)) and (Red in Panel.lit => always (after Red not in Panel.lit)) }

#### XXX.tsv = ((BadStateQuantification))
- BSQ = G(_U_)

#### YYY.tsv = ((BadStateQuantification))
- The second conjunct (in the scope of outermost `always`) is preventing the light from being on more than once; I think after/always ordering doesn't matter here. The strong `until` is inside the `always`, forcing the light to remain on. Since this is about quantifier behavior, I'm coding this one BadStateQuantification. Note that they've carefully used parens to avoid a precedence issue with and/implies. (Also, if I'm right, this one is unsatisfiable.)


### column H
> Q. The Red light is on in exactly one state, but not necessarily the first state
> A. eventually Red in Panel.lit always Red not in Panel.lit until Red in Panel.lit always Red not in Panel.lit after Red in Panel.lit

#### XXX.tsv = ((BadStateIndex and BadStateQuantification))
- BSQ = bad U no matter how parenthesized + G(!R), BSI = toplevel X ... intended as binop?

#### YYY.tsv = ((WeakUntil))
- Interesting! Note the "eventually lit" alongside "unlit until lit". This reveals a  WeakUntil (by both the rubric and rationale) -- but without changing the meaning of the answer! I also believe this is a binary `after`, although we'd need to look at the exact newline positioning to be sure. This is hard for me to code beyond WeakUntil: there's more that's wrong, but untangling it using the existing codes is tough.
- BinaryAfter
- Leftovers


### column I
> Q. The Red light is on in exactly one state, but not necessarily the first state
> A. (eventually (Red in Panel.lit)) until (eventually (Red not in Panel.lit))

#### XXX.tsv = ((BadStateQuantification))
- BSQ = wrong quantification ... this is very weird!!!

#### YYY.tsv = ((BadStateQuantification))
- Another tough one: there's obviously a mis-use of temporal quantifiers. But I have no real confidence beyond that; I'm unsure what the student was trying to do.
- Leftovers


### column J
> Q. The Red light is on in exactly one state, but not necessarily the first state
> A. Red in Panel.lit implies after {always Red not in Panel.lit}

#### XXX.tsv = ((ImplicitF and ImplicitG))
- IF = assume implies lhs sat., IG = formula needs to constrain every state

#### YYY.tsv = ((ImplicitF and ImplicitG))
- ImplicitF because they left out forcing the light to be lit at all. ImplicitG because what's here is an attempt to force the light to never be on more than once, but it only works in the first state.


### column K
> Q. The Red light is on in exactly one state, but not necessarily the first state
> A. { Red not in Panel.lit until Red in Panel.lit } and { Red in Panel.lit => !(eventually Red in Panel.lit) }

#### XXX.tsv = ((ImplicitG))
- IG = and rhs

#### YYY.tsv = ((ImplicitG))
- This is an implicitG by the rubric, since the second conjunct only applies in the first state and I believe it's correct if turned global. However, it's also possible that the student meant for the state to be carried over (`and then').
- AndThen


### column L
> Q. The Red light is on in exactly one state, but not necessarily the first state
> A. (Red in Panel.lit or Red in Panel.lit') and not (Red in Panel.lit and Red in Panel.lit') and after after {(always not Red in Panel.lit)}

#### XXX.tsv = ((ReasonableVariant))
- M = 1st or 2nd only

#### YYY.tsv = ((ReasonableVariant))
- One of the first two is lit. But note priming.
- PRIMING!!! (I forget: did we ask them not to use that?)


### column M
> Q. The Red light cannot stay lit for three states in a row.
> A. (Red in Panel.lit) implies ((after not Red in Panel.lit) and (after after not Red in Panel.lit))

#### XXX.tsv = ((BadProp and ImplicitG))
- IG = toplevel, BP = and vs or

#### YYY.tsv = ((BadProp and ImplicitG))
- It looks like this student made an LTL mistake: ImplicitG. But they're also using an "and" instead of "or": BadProp


### column N
> Q. The Red light cannot stay lit for three states in a row.
> A. always {Red in Panel.lit implies {after Red not in Panel.lit} or {after {after Red not in Panel.lit}} or {after {after {after Red not in Panel.lit}}}}

#### XXX.tsv = ((ReasonableVariant))
- M = 3 vs 4

#### YYY.tsv = ((ReasonableVariant))
- Four steps in a row


### column O
> Q. The Red light cannot stay lit for three states in a row.
> A. Red not in Panel.lit until (after after after Red in Panel.lit)

#### XXX.tsv = ((BadStateQuantification))
- BSQ = until is just wrong ... baffling

#### YYY.tsv = ()
- Tough to code. They might be using WeakUntil and ImplicitG, but even then, it's wrong.


### column P
> Q. The Red light cannot stay lit for three states in a row.
> A. ((Red in Panel.lit) and (after Red in Panel.lit)) implies after (Red not in Panel.lit)

#### XXX.tsv = ((BadStateIndex and ImplicitG))
- IG = toplevel, BSI = impliesThen

#### YYY.tsv = ((ImplicitG))
- Just missing the global quantifier


### column Q
> Q. The Red light cannot stay lit for three states in a row.
> A. always { Red in Panel.lit implies after {Red in Panel.lit implies after {Red in Panel.lit implies after {Red not in Panel.lit}}}}

#### XXX.tsv = ((BadProp and ReasonableVariant))
- M = 3 vs 4, BP = implies vs and

#### YYY.tsv = ((ReasonableVariant))
- Looks like an off-by-one. Lit -> Lit -> Lit -> Unlit.


### column R
> Q. The Red light cannot stay lit for three states in a row.
> A. always{Red in Panel.lit implies after{after{Red not in Panel.lit}}}

#### XXX.tsv = ((OtherImplicit))
- OI = thinking XX is for 1st or 2nd?? could be ReasonableVariant

#### YYY.tsv = ()
- Either "spreading after" or just inattentiveness. But it doesn't fit any of our codes as written. It's not a BadStateIndex or BadProp.


### column S
> Q. Whenever the Red light is on, the Blue light will turn on at some point.
> A. always{ Red in Panel.lit implies Blue in Panel.lit }

#### XXX.tsv = ((ImplicitF))
- IF = missing F that's all

#### YYY.tsv = ((ImplicitF))
- There seem to be 2 variants of ImplicitF: forgot an F (as here) or something more subtle involving the assumption that some subterm is ever true. But both are listed in the rubric, so there's no ambiguity.


### column T
> Q. Whenever the Red light is on, the Blue light will turn on at some point.
> A. {Red in Panel.lit} and eventually Blue in Panel.lit

#### XXX.tsv = ((BadProp and ImplicitG))
- BP = and vs implies, IG = toplevel

#### YYY.tsv = ((BadProp and ImplicitG))
- Combination of two basic errors.


### column U
> Q. Whenever the Red light is on, the Blue light will turn on at some point.
> A. always { Red in Panel.lit implies { eventually {Blue not in Panel.lit and after {Blue in Panel.lit}} } }

#### XXX.tsv = ((ReasonableVariant))
- M = interpreted "turn on" as flip from off to on .... simply being on is not enough

#### YYY.tsv = ((ReasonableVariant))
- Forcing flip, not just being on. (And on reflection, this interpretation might be "more correct" than ours!)


### column V
> Q. The Red light is lit for a finite number of steps, and then never again becomes lit.
> A. eventually{Red in Panel.lit } and eventually{Red not in Panel.lit} and always{ { Red in Panel.lit and after{Red not in Panel.lit}} => after{always{Red not in Panel.lit}} }

#### XXX.tsv = ((BadStateQuantification and ReasonableVariant))
- M = unlit prefix, BSQ = first F is bad ... seems to assume 1st F happens before 2nd F, which isn't quite BSQ or BSI (index is not specific) or OI (implicit order?) but I'm going with BSQ ~ extra F 

#### YYY.tsv = ((ReasonableVariant))
- It's lit at some point. It's unlit at some point. If it ever turns from on to off, it stays off. This isn't Y.2 because it doesn't enforce starting lit. But it doesn't admit the fully unlit trace, either. I believe this is Y.1 (allowing an unlit prefix) then.


### column W
> Q. The Red light is lit for a finite number of steps, and then never again becomes lit.
> A. {always Red in Panel.lit} until {always {not Red in Panel.lit}}

#### XXX.tsv = ((BadStateQuantification))
- BSQ = ((G_)U_) is bad

#### YYY.tsv = ((BadStateQuantification))
- I think this ONLY admits the always-unlit trace. That's not either of our misconceptions. I think this is a BadStateQuantifier because of the first always.


### column X
> Q. The Red light is lit for a finite number of steps, and then never again becomes lit.
> A. always { Red in Panel.lit implies { after { Red in Panel.lit or always Red not in Panel.lit } } } and eventually {Red in Panel.lit and eventually Red not in Panel.lit}

#### XXX.tsv = ((ReasonableVariant))
- M = allows any prefix before F kicks in

#### YYY.tsv = ((ReasonableVariant))
- Lit at some point. Unlit at some point. I beleive this is targeting Y.1, but still not correct. This admits the always-lit trace, which should be excluded.  My guess: they aren't thinking inductively. "If it's lit, well, either it stops being lit or it takes a bit longer..." I'm unsure what to code this. It's not "bad quantification" because the always is needed. It's not bad prop, either: the problem is the plan, not the execution.
- There isn't a way to distinguish between "this ReasonableVariant + correct" vs. "this ReasonableVariant + incorrect but I don't know how to code it." I suppose that can be disambiguated by the solver, though.


### column Y
> Q. The Red light is lit for a finite number of steps, and then never again becomes lit.
> A. (eventually Red in Panel.lit) and ((always Red in Panel.lit) until (not Red in Panel.lit)) and (eventually always not Red in Panel.lit)

#### XXX.tsv = ((BadStateQuantification and ReasonableVariant))
- BSQ = ((G_)U_), the end. seems to allow unlit prefix and to have an imperative intuition though!

#### YYY.tsv = ((ReasonableVariant))
- 3 conjuncts: Lit at some point. Likely attempt to enforce contiguous illumination.  Turns off forever at some point. I think this is another Y.1 that's still wrong in a subtle way. The `always` on the LHS of an until is very odd. (This is the answer that made me add the question in the rubric re: students using parens wrong, rather than omitting them. But I'm not even sure if removing/replacing would fix this.)


### column Z
> Q. The Red light is lit for a finite number of steps, and then never again becomes lit.
> A. eventually ((Red in Panel.lit) and (after (eventually always(not(Red in Panel.lit)))))

#### XXX.tsv = ((OtherImplicit and ReasonableVariant))
- M = unlit prefix, OI = assumes no flips between the F's

#### YYY.tsv = ((OtherImplicit and ReasonableVariant))
- Allows an unlit prefix (ReasonableVariant). But also allows alternation, which is OtherImplicit.  (Is this equivalent to AE? If so it'd strengthen the case for another ReasonableVariant type.)


### column [
> Q. The Red light is lit for a finite number of steps, and then never again becomes lit.
> A. (Red in Panel.lit) until (Red not in Panel.lit) (Red not in Panel.lit) implies always (Red not in Panel.lit)

#### XXX.tsv = ((ImplicitG))
- IG after hidden and, that's all --- so close

#### YYY.tsv = ((ImplicitG))
- I think this would be fine if only that second constraint was globalized. 


### column \
> Q. The Red light is lit for a finite number of steps, and then never again becomes lit.
> A. eventually { Red in Panel.lit eventually Red not in Panel.lit after { (Red in Panel.lit) or (always Red not in Panel.lit) } }

#### XXX.tsv = ((ImplicitG and ReasonableVariant))
- M = unlit prefix, IG = at after ... weird nested formula but pretty close

#### YYY.tsv = ((OtherImplicit and ReasonableVariant))
- Allows an unlit prefix but requires eventually lit (Y.1). But still wrong: nothing prevents switching on and off until that outer `eventually` triggers. This isn't implicitF (the F is explicit!) but it is an OtherImplicit related to when that eventually triggers. (Also possibly an unnamed ReasonableVariant that allows blinking -- but that's not in the rubric.)
- Unsure if BinaryAfter without seeing newlines.


### column ]
> Q. The Red light is lit for a finite number of steps, and then never again becomes lit.
> A. Red in Panel.lit and eventually {Red not in Panel.lit} and (Red not in Panel.lit implies after {always {Red not in Panel.lit}})

#### XXX.tsv = ((ImplicitG))
- IG after 2nd and

#### YYY.tsv = ((ReasonableVariant))
- Forces the light to start out lit.


