NOTE: if a formula is very complex / confusing, don't apply any tags. We can examine it later for a discussion (shows the extent of the confusion you can get from LTL ... imagine doing synthesis based off this formula, how far off is that result from the original English spec?!)

- BadProp : Mis-use/swap a logical operator or atom (may have misunderstood the definition).
    - Expected `a0 => a1` but learner wrote `a0 and a1`
    - Expected `a0 => a1` but learner wrote `a0 => a0`

- BadStateIndex : Write a correct term at the wrong time/state index. Both the actual and expected times must be specific, to avoid overlap with ImplicitF and ImplicitG.
    - Expected `a0 U (a1 and F(a2))` but learner wrote `(a0 U a1) and F(a2)`
    - Expected `a0 and X(a1)` but learner wrote `a0 and a1`
    - Expected `X(a0)` but learner wrote `XX(a0)`

- BadStateQuantification : Mis-use/swap a temporal operator (may have misunderstood the definition).
    - Expected `F(a0)` but learner wrote `G(a0)`
    - Expected `a0 U a1` but learner wrote `G(a0) U a1`
    - Expected `a0 => X(a1)` but learner wrote `X(a0, a1)` or rather `a0 X a1`

- ImplicitF : Assume that a formula (or subformula) happens at some point.
    - Expected `F(a0)` but learner wrote `a0`
    - Expected `F(a0) and G(a0 => a1)` but learner wrote `G(a0 => a1)`

- ImplicitG : Assume that a formula (or subformula) constrains all future states.
    - Expected `G(a0)` but learner wrote `a0`

- OtherImplicit : Omit some constraints from a formula, perhaps assuming that traces will not include unspecified behaviors. Do not apply this tag when ImplicitF or ImplicitG would work.
    - Expected `!a0 U a0` but learner wrote `F(a0)`
    - Expected `a0 U G(!a0)` but learner wrote `a0 and F(G(!a0))`
    - Expected `F(a0) and G(a0 => XG(!a0))` but learner wrote `F(a0 and XG(!a0))`

- WeakUntil : Confuse U with weak-U.


- Precedence : META-TAG, student made a typo-level mistake omitting some parentheses. Do not apply this tag for major errors, e.g., if the formula would express two different misconceptions depending on the parentheses.

- Miscomm : META-TAG, use for valid mis-interpretations of the question

